# Result Protocol Plugin

This unofficial TaleSpire plugin adds a result protocol to the Talespire URL Relay allowing
rolls outside of Talespire to be rolled and posted in Talespire. Contains an option to show
spinning dice in Talespire or just posting the results. Comes with a Chrome Extension to
post DnD Beyond rolls to Talespire.

This plugin, like all others, is free but if you want to donate, use: http://LordAshes.ca/TalespireDonate/Donate.php

## Change Log
```
1.0.0: Initial release
```

## Install

Install using R2ModMan or similar.

The plugin contains a configuration which determines if you want to see the spinning dice
in Talespire or not. Please note that the spinning dice are not actual dice rolls, they
show up in the center of the view and spin ending on the posted results.

Unlike most other Chrome Extension solutions, this solution does **not** need Beyond Link via Chrome.

### With Dnd Beyond

Install the DnD Beyond Roller Chrome Extension

## Usage

### With DnD Beyond
```
1. Start Talespire with the plugin installed.
2. Open up a Dnd Beyond Character sheet.
3. Click on any element that causes a dice roll.
   (Dice rolls are limited to anything in the format #D#+# which means the plugin does not
    support multiple dice rolls at once such as #D#+#+#D#+#).
4. After the result is generated in Dnd Beyond, the same result will be optionally rolled and
   then disaplayed in Talspire.
5. Before making additional rolls make sure that the previous result is clear. Failure to do
   so will mean that the result will not get posted in Talespire correctly.
```
### With Other Sources

This plugin, while enabled, adds a new result protocol to the Talespire URL Relay. This means
that any application or web page that can request a URL should be able to trigger this functionality.
The format for the protocol is:
```
talespire://result/name/formula/die1/die2/die3/...
```
For example, for a greatsword damage roll might look like:
```
talespire://result/Greatsword (Damage)/2D6+4/3/6
```
The number of entries after the formula, separated by slashes, must match the formula. If there are
extra entries they will be ignored but insufficient entries will cause an error.

From Javascript (such as Chrome Extension or your own web page) you can use:
```
let url = "talespire://result/Attack/1D20+7/15"
window.open(url, "_blank");
```

## Customization

The plugin has a configuration for the Asset Bundle Name for the dice. Normally it should not be
necessary to change this. It uses the same asset bundle as Custom Dice Pack plugin but the base dice
asset bundle is provided again so that you don't need the Custom Dice Pack plugin.

In addition, there is a texture suffix configuration. The plugin comes with a Black And White (BW)
texture theme but the dice textures can be customized by changing the suffix configruation. The
texture name is determined for each die by suffixing the configured text to the die type and placing
a underscore in between. For example, if the Suffix is ``Lava`` then the expected textures would be
``d4_Lava.png``, "d6_Lava.png``, ..., ``d20_Lava.png``. The file type (and thus the extension) does
not need to be PNG but PNG is commonly used.
die uses a texture that 